#ifndef PARTICLE_EMITER_H
#define PARTICLE_EMITER_H

#include <boost/shared_ptr.hpp>

class ParticleSystem;

// emiter czsteczek
class ParticleEmiter
{
protected:
	// akumulator czasu
	float timeAccumulator;

	// co ile czasu ma by generowana czsteczka
	float timePerParticle;

	ParticleEmiter(float particlesPerSecond) 
		: timeAccumulator(0), timePerParticle(1 / particlesPerSecond) 
	{
	}
public:
	// aktualizacja / generowanie czsteczek
	virtual bool Update(ParticleSystem* ps, float dt) = 0;
	virtual ~ParticleEmiter() { }
};

typedef boost::shared_ptr<ParticleEmiter> ParticleEmiterRef;

#endif