#ifndef SAMPLE_EMITER_H
#define SAMPLE_EMITER_H

#include "ParticleEmiter.h"

class SampleEmiter : public ParticleEmiter
{
public:
	SampleEmiter(float particlesPerSecond) 
		: ParticleEmiter(particlesPerSecond)
	{
	}

	bool Update(ParticleSystem* ps, float dt)
	{
		// zwikszenie akumulatora o ilo czasu, ktra mina od ostatniej aktualizacji
		timeAccumulator += dt;

		// generowanie czsteczek zalene od czasu
		while (timeAccumulator > timePerParticle)
		{
			// utworzenie czsteczki
			Particle* particle = ps->CreateParticle();

			// uzupenienie parametrw
			particle->position = Vec2D(320, 240);
			
			particle->velocity = ps->random.GetPointOnCircle(ps->random.GetFloat(20, 100));
			
			particle->current.color = ps->random.GetOpaqueColor();
			particle->current.angle = ps->random.GetAngle();
			particle->current.size = ps->random.GetFloat(2, 4);

			particle->change.color = ps->random.GetTransparentColor();
			particle->change.angle = ps->random.GetAngle();
			particle->change.size = ps->random.GetFloat(4, 32);
			particle->changeDuration = ps->random.GetFloat(1, 3);

			particle->CalculateChangePerSecond();

			// zmniejszenie wartoci akumulatora
			timeAccumulator -= timePerParticle;
		}

		return true;
	}
};

#endif