#ifndef SIMPLE_PROFILER_H
#define SIMPLE_PROFILER_H

#include "RenderingHelper.h"
#include <SDL/SDL.h>

class SimpleProfiler
{
	RenderingHelper* helper;
	int y;
	const char* label;

	Uint32 startTime;

public:
	SimpleProfiler(RenderingHelper* helper, int y, const char* label)
		: helper(helper), y(y), label(label)
	{
		startTime = SDL_GetTicks();
	}

	~SimpleProfiler()
	{
		int dt = SDL_GetTicks() - startTime;
		helper->WriteDebugLine(y, "%s: %i ms", label, dt);
	}
};


#endif