#ifndef SNOWFLAKE_EMITER_H
#define SNOWFLAKE_EMITER_H

#include "ParticleEmiter.h"

class SnowflakeEmiter : public ParticleEmiter
{
	const UVRegion* regions[4];
	int type;

public:

	SnowflakeEmiter(float particlesPerSecond, const TextureRef& texture) 
		: ParticleEmiter(particlesPerSecond), type(0)
	{
		regions[0] = texture->GetNamedRegion("type1");
		regions[1] = texture->GetNamedRegion("type2");
		regions[2] = texture->GetNamedRegion("type3");
		regions[3] = texture->GetNamedRegion("type4");
	}

	bool Update(ParticleSystem* ps, float dt)
	{
		timeAccumulator += dt;

		while (timeAccumulator > timePerParticle)
		{
			Particle* particle = ps->CreateParticle();

			particle->position.x = ps->random.GetFloat(0, 640);
			particle->position.y = -20;

			particle->velocity = ps->random.GetVec2D(-10, 10, 100, 150);
			
			particle->current.color = Color(1, 1, 1, 1);
			
			particle->current.angle = ps->random.GetAngle();
			particle->current.size = ps->random.GetFloat(16, 32);

			particle->change.color = Color(1, 1, 1, 1);
			particle->change.angle = particle->current.angle + ps->random.GetFloat(3.1415f / 4, 3.1415f);
			particle->change.size = ps->random.GetFloat(8, 16);
			particle->changeDuration = ps->random.GetFloat(4, 8);

			particle->CalculateChangePerSecond();

			// wybr odpowiedniego regionu
			particle->uvRegion = regions[type];

			type = (type + 1) % 4;

			timeAccumulator -= timePerParticle;
		}

		return true;
	}
};

#endif